require "import"
import "android.widget.*"
import "android.content.*"
import "android.net.Uri"
import "com.androlua.*"
import "android.os.Vibrator"

-- Contexto
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)

-- Enlaces de redes sociales
local redes = {
  {nombre = "Canal de WhatsApp", url = "https://whatsapp.com/channel/0029Vb5TFj1H5JM8QaWGZy3w"},
  {nombre = "Canal de YouTube", url = "https://youtube.com/@audiosaccesibles?si=QDd9bUQVqFVMBpXZ"},
  {nombre = "Canal de Telegram", url = "https://t.me/udiosaxesibles"},
  {nombre = "Perfil de TikTok", url = "https://www.tiktok.com/@audios.accesibles?_t=ZS-8wE3GC28khG&_r=1"},
}

-- Función para abrir un enlace
function abrirEnlace(url)
  if url and url ~= "" then
    local intent = Intent(Intent.ACTION_VIEW)
    intent.setData(Uri.parse(url))
    context.startActivity(intent)
    service.asyncSpeak("Abriendo enlace: " .. url)
    vibrator.vibrate(100)
  else
    service.asyncSpeak("El enlace no está disponible.")
  end
end

-- Crear diseño dinámico con botones
local layoutBotones = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "match_parent",
  layout_height = "match_parent",
  padding = "16dp",
}

-- Agregar botón por cada red social
for _, red in ipairs(redes) do
  table.insert(layoutBotones, {
    Button,
    text = red.nombre,
    onClick = function() abrirEnlace(red.url) end,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_marginBottom = "12dp",
  })
end

-- Botón para cerrar
table.insert(layoutBotones, {
  Button,
  text = "Cerrar",
  onClick = function()
    dlg.dismiss()
    vibrator.vibrate(60)
  end,
  layout_width = "wrap_content",
  layout_height = "wrap_content",
  layout_gravity = "end",
})

-- Mostrar diálogo con los botones
dlg = LuaDialog(service)
dlg.setTitle("Redes Sociales - Audios Accesibles")
dlg.View = loadlayout(layoutBotones)
dlg.show()